.INCLUDE CRASH82.INC

;simple equates from sos83 to crash82

SAVESSCREEN = APD_BUF
plotsscreen = GRAPH_MEM
_grbufcpy_V = CR_GRBCopy
_divhlbya = DIV_HL_A
penrow = CURSOR_Y
pencol = CURSOR_X
currow = CURSOR_ROW
curcol = CURSOR_COL


kDown = 254 
kLeft = 253 
kRight = 251 
kUp = 247 
k2nd = 223
kMode = 191

NUMROWS = 41    ; number of rows
NUMCOLS = 50    ; number of columns
STARTSPOT = 1725  ; NUMCOLS * 38 + 29  (that is number of rows down and across

mapstart = SAVESSCREEN    
yourspot = SAVESSCREEN+2
chspot = SAVESSCREEN+4
chprev = SAVESSCREEN+6       ; SAVESSCREEN is the start of the APD variable
dir = SAVESSCREEN+7	     ; storage location... It is a good place to
time = SAVESSCREEN+8	     ; store variables
smallTime = SAVESSCREEN+9
chleft = SAVESSCREEN+10
level = SAVESSCREEN+11
temp = SAVESSCREEN+12


desc: .db "Chicken Shoot v1.1 by HM",0

prog_start:
	 set 7,(iy+$14)        ; This *should* be already done...

restartGame:
 xor a
 ld (level),a
nextLevel:
 ld a,(level)   ; increase the level by 1
 inc a
 cp 9
 jr z,restartGame

 ld (level),a
 ld (chleft),a   ; level = number of chickens to kill per level

 call _grbufclr    	; clear the graph buffer
 call showTITLE

 ld a,56	; X-coordinate for SPRITE
 ld e,24	; Y-coordinate for SPRITE
 ld hl,manl1    ; pointer to SPRITE
 call SPRITE    ; draw SPRITE    (top of man)

 ld a,56	
 ld e,32
 ld hl,manl2
 call SPRITE	; bottom of man

 ld a,24
 ld e,32
 ld hl,chicken  ; draw the chicken
 call SPRITE

 ld hl,57*256+0
 ld (pencol),hl
 ld hl,intro_text2
 ROM_CALL(D_ZM_STR)

 ld a,(level)
 ld b,a
 xor a
setTheTimer:
 add a,30
 djnz setTheTimer
 ld (time),a

 call disp8bits

 ld hl,57*256+56
 ld (pencol),hl
 ld hl,intro_text3
 ROM_CALL(D_ZM_STR)
 
 ld hl,hiscs
 ld a,(level)
 ld e,a
 ld d,0
 add hl,de
 ld a,(hl)
 call disp8bits

 call _grbufcpy_V

 ld hl,0606h
 ld (currow),hl
 ld a,(level)
 ld l,a
 ld h,0
 ROM_CALL(D_HL_DECI)     		; which level? 

 ld hl,0406h
 ld (currow),hl
 ld hl,intro_text1
 ROM_CALL(D_ZT_STR)

 call wait

stgame:
 xor a
 ld (smallTime),a
 ld (dir),a

 ld hl,map+STARTSPOT
 ld (mapstart),hl             ; mapstart on screen
 ld hl,map+STARTSPOT+204      ; offset where you start (see STARTSPOT)
 ld (yourspot),hl
 jp nuchick

MoveLeft:
	ld a,3
	ld (dir),a
        ld hl,(yourspot)             
        dec hl
        ld a,(hl)
        cp 3
        jr nc,keyloop          
        ld (yourspot),hl
        ld hl,(mapstart)             ; decrease your spot
        dec hl
        ld (mapstart),hl
        jr keyloop

MoveRight:
	ld a,1
	ld (dir),a
        ld hl,(yourspot)
        inc hl                       ; same stuff
        ld a,(hl)
        cp 3
        jr nc,keyloop          
        ld (yourspot),hl
        ld hl,(mapstart)
        inc hl
        ld (mapstart),hl
        jr keyloop

MoveUp:
	xor a
	ld (dir),a
        ld hl,(yourspot)
        ld de,NUMCOLS
	sbc hl,de
        ld a,(hl)                   ; next/previous row
        cp 3
        jr nc,keyloop   
	xor a        
        ld (yourspot),hl
        ld hl,(mapstart)
	sbc hl,de
        ld (mapstart),hl
        jr keyloop

MoveDown:
	ld a,2
	ld (dir),a
        ld hl,(yourspot)
        ld de,NUMCOLS
	add hl,de
        ld a,(hl)
        cp 3
        jr nc,keyloop               ; and more
        ld (yourspot),hl
        ld hl,(mapstart)
	add hl,de
        ld (mapstart),hl

keyloop:
 call delay

 call drawmap

 ld a,(dir)
 push af
 or a
 call z,dup
 pop af
 push af
 cp 1
 call z,drt
 pop af
 push af
 cp 2
 call z,ddn
 pop af
 cp 3
 call z,dlf

 ld hl,55*256+81
 ld (pencol),hl
 ld a,(time)
 call disp8bits

 ld hl,8*256+83
 ld (pencol),hl
 ld a,(chleft)
 call disp8bits

 call _grbufcpy_V

 ld a,(smallTime)
 inc a
 ld (smallTime),a
 cp 9
 jr c,notNEXTsecond	; decided to INLINE this function!!!

 xor a
 ld (smallTime),a
 
 ld a,(time)
 dec a
 jp z,outOFtime
 ld (time),a

 ld de,map
 ld hl,(chspot)
 xor a
 sbc hl,de		; subtract chspot from the map enabling us to do the math

 ld a,NUMCOLS
 call _divhlbya		; hl/a = hl + a(remainder)

 push af		
  ld a,l
  srl a
  add a,18
  ld e,a
 pop af

 srl a
 add a,74
 cp 89
 jr c,noRSTxpos
 ld a,88
noRSTxpos:
 ld hl,chicken
 call SPRITE		; print from (74,18) to (87,37) = 13x19 area
			;   centered at 81,28
 call _grbufcpy_V
 call delay

notNEXTsecond:
 ld a,0ffh		;reset keyport
 out (1),a		;necessary code
 ld a,0FEh          ; Check the arrow keys
 out (1),a
 in a,(1)
 cp kDown  
 jp z,MoveDown  
 cp kLeft
 jp z,MoveLeft  
 cp kRight
 jp z,MoveRight
 cp kUp
 jp z,MoveUp

 ld a,$BF          ; Check 2nd and more
 out (1),a
 in a,(1)
 cp k2nd
 jp z,shoot
 cp kMode
 jr nz,theCHICKENmoves

 ld hl,(chspot)
 ld a,(chprev)
 ld (hl),a
 ret


theCHICKENmoves:
 call getrand
 cp 150
 jp nc,keyloop

 push af
  ld hl,(chspot)
  ld a,(chprev)
  ld (hl),a
 pop af

 and %11
 or a
 jp z,cdn
 cp 1
 jp z,crt
 cp 2
 jp z,cup

clf:
 ld hl,(chspot)
 dec hl
 ld a,(hl)
 cp 3
 jr nc,theCHICKENmoves
 ld (chprev),a
 ld (hl),10
 ld (chspot),hl
 jp keyloop

crt:
 ld hl,(chspot)
 inc hl
 ld a,(hl)
 cp 3
 jr nc,theCHICKENmoves
 ld (chprev),a
 ld (hl),10
 ld (chspot),hl
 jp keyloop

cup:
 ld hl,(chspot)
 ld de,NUMCOLS
 xor a
 sbc hl,de
 ld a,(hl)                   ; next/previous row
 cp 3
 jr nc,theCHICKENmoves
 ld (chprev),a
 ld (hl),10
 ld (chspot),hl
 jp keyloop

cdn:
 ld hl,(chspot)
 ld de,NUMCOLS
 add hl,de
 ld a,(hl)
 cp 3
 jr nc,theCHICKENmoves
 ld (chprev),a
 ld (hl),10
 ld (chspot),hl
 jp keyloop


getrand:
	ld a,(randseed)
	ld b,a
	ld a,r
	add a,b
	sla b
	sla b
	add a,b
	sla b	
	sla b
	add a,b
	add a,e
	inc a
	rrc a
	ld (randseed),a
	ret

randseed: .db %10101010


dup:
 ld a,32
 ld e,28
 ld hl,manu1
 call SPRITE
 ld a,32
 ld e,36
 ld hl,manu2
 call SPRITE
 ret

drt:
 ld a,32
 ld e,28
 ld hl,manr1
 call SPRITE
 ld a,32
 ld e,36
 ld hl,manr2
 call SPRITE
 ret

ddn:
 ld a,32
 ld e,28
 ld hl,mand1
 call SPRITE
 ld a,32
 ld e,36
 ld hl,mand2
 call SPRITE
 ret

dlf:
 ld a,32
 ld e,28
 ld hl,manl1
 call SPRITE
 ld a,32
 ld e,36
 ld hl,manl2
 call SPRITE
 ret



drawmap:
 call _grbufclr
 call displaySIDEBAR

 ld hl,(mapstart)
 ld de,plotsscreen   

 ld c,8
drawMapY:
 ld b,9
drawMapX:
 ld a,(hl)
 cp 11
 jr nc,tileISempty
 or a
 jr z,tileISempty
  push hl
   push bc
    ld b,a
    push de
     ld hl,SPRITEs-8
getSPRITE:
     ld de,8
     add hl,de
     djnz getSPRITE
    pop de

    push de
     ld a,8
drawTILE:
     ldi
     push hl
      ld hl,11
      add hl,de
      ex de,hl
     pop hl
     dec a
     jr nz,drawTILE

    pop de
   pop bc
  pop hl

tileISempty:
  inc hl
  inc de
  djnz drawMapX

  push de
   ld de,NUMCOLS-9		; we moved over 9 columns during the X loop.
   add hl,de			;   so we only need to advance totalCOLS - 9.
  pop de

  push hl
   ld hl,87			; de = de + 12(BytesPerRow)*7(ColsDown)+3(extra bytes for sidebar)
   add hl,de
   ex de,hl
  pop hl

  dec c
  jr nz,drawMapY
  ret


shoot:
 ld a,(dir)
 cp 1
 jr z,ShootRight
 or a
 jr z,ShootUp
 cp 2
 jp z,ShootDown

ShootLeft:
 ld a,24	; bullet position
 ld hl,(yourspot)
BulletLeftLoop:
 dec hl
 push hl
 ld de,(chspot)
 sbc hl,de
 jp z,HitTheChicken
 push af
 ld e,32
 ld hl,shot
 call SPRITE
 call _grbufcpy_V
 pop af
 push af
 ld e,32
 ld hl,shot
 call CLRSPR
 call delay
 pop af
 pop hl
 sub 8
 jr nc,BulletLeftLoop

 jp keyloop

ShootUp:
 ld a,24
 ld (temp),a
 ld hl,(yourspot)
BulletUpLoop:
 xor a
 ld de,NUMCOLS
 sbc hl,de
 push hl
 ld de,(chspot)
 sbc hl,de
 jp z,HitTheChicken
 ld a,(temp)
 ld e,a
 ld a,32
 ld hl,shot
 call SPRITE
 call _grbufcpy_V
 ld a,(temp)
 ld e,a
 ld a,32
 ld hl,shot
 call CLRSPR
 call delay
 pop hl
 ld a,(temp)
 sub 8
 ld (temp),a
 jr nc,BulletUpLoop

 jp keyloop


ShootRight:
 ld a,40	; bullet position
 ld hl,(yourspot)
BulletRightLoop:
 inc hl
 push hl
 ld de,(chspot)
 sbc hl,de
 jr z,HitTheChicken
 push af
 ld e,32
 ld hl,shot
 call SPRITE
 call _grbufcpy_V
 pop af
 push af
 ld e,32
 ld hl,shot
 call CLRSPR
 call delay
 pop af
 pop hl
 add a,8
 cp 72
 jr nz,BulletRightLoop

 jp keyloop

ShootDown:
 ld a,40
 ld (temp),a
 ld hl,(yourspot)
BulletDownLoop:
 ld de,NUMCOLS
 add hl,de
 push hl
 ld de,(chspot)
 sbc hl,de
 jr z,HitTheChicken
 ld a,(temp)
 ld e,a
 ld a,32
 ld hl,shot
 call SPRITE
 call _grbufcpy_V
 ld a,(temp)
 ld e,a
 ld a,32
 ld hl,shot
 call CLRSPR
 call delay
 pop hl
 ld a,(temp)
 add a,8
 ld (temp),a
 cp 64
 jr nz,BulletDownLoop

 jp keyloop

HitTheChicken:
 pop hl

kill:
 call Flash
 call Flash

 ld a,(chprev)
 ld hl,(chspot)
 ld (hl),a

 ld a,(chleft)
 dec a
 jr z,youWin
 ld (chleft),a

nuchick:
 call getrand
 and %11
 or a
 jr z,stmap4
 cp 1
 jr z,stmap2
 cp 2
 jr z,stmap3

stmap1:
 ld hl,355+map
 ld (chspot),hl
 ld a,(hl)
 ld (chprev),a
 jp keyloop

stmap2:
 ld hl,398+map
 ld (chspot),hl
 ld a,(hl)
 ld (chprev),a
 jp keyloop

stmap3:
 ld hl,1815+map
 ld (chspot),hl
 ld a,(hl)
 ld (chprev),a
 jp keyloop

stmap4:
 ld hl,1391+map
 ld (chspot),hl
 ld a,(hl)
 ld (chprev),a
 jp keyloop

youWin:
 call _grbufclr    	; clear the graph buffer
 call showTITLE

 ld hl,24*256+5
 ld (pencol),hl
 ld hl,win1
 ROM_CALL(D_ZM_STR)

 call _grbufcpy_V

 ld hl,0205h
 ld (currow),hl
 ld hl,tstr
 ROM_CALL(D_ZT_STR)

 ld a,(level)
 ld b,a
 ld c,30
 xor a
winMULTloop:
 add a,c
 djnz winMULTloop

 ld l,a
 ld h,0
 ld a,(time)
 ld e,a
 ld d,0
 xor a
 sbc hl,de
 push hl
 ROM_CALL(D_HL_DECI)

 pop bc		; auto l into c
 ld hl,hiscs
 ld a,(level)
 ld e,a
 ld d,0
 add hl,de
 ld a,(hl)
 cp c
 jr nc,newhi
winlp:
 call wait
 jp nextLevel

newhi:
 ld a,c
 ld (hl),a
 ld hl,0107h
 ld (currow),hl
 ld hl,aNewHighScore_String
 ROM_CALL(D_ZT_STR)
 jr winlp


outOFtime:
 ld a,(chprev)
 ld hl,(chspot)
 ld (hl),a

 call Flash

 call _grbufclr    	; clear the graph buffer
 call showTITLE
 call _grbufcpy_V

 ld hl,0404h
 ld (currow),hl
 ld hl,gmover
 ROM_CALL(D_ZT_STR)
 jr wait

delay:
 ei
 halt
 halt
 halt
 halt
 halt
 ret

suprd:
 ld b,17
 ei
spd:
 halt
 djnz spd
 ret

wait:
 xor a
 ei
waitLOOP:
 halt
 dec a
 jr nz,waitLOOP
 ret

Flash:
 call revscreen
 call _grbufcpy_V
 call suprd
 call revscreen
 call _grbufcpy_V
 jr suprd


revscreen:
 ld hl,plotsscreen
 ld bc,768
rloop:
 ld a,(hl)
 cpl
 ld (hl),a
 inc hl
 dec bc
 ld a,b
 or c
 jr nz,rloop
 ret

showTITLE:
 ld hl,cstitl       	; load the label for the picture into the data pointer
 ld de,plotsscreen+13  	; starting memory location for writing to graph buffer
 ld bc,210       	; # of bytes to paint
 ldir		 	; load them together!
 ret

displaySIDEBAR:
 ld de,plotsscreen+9		; de's coords are x=72 y=0
 ld hl,sidebar
 ld a,64
sidebar_loop:
 ld bc,3
 ldir
 push hl
  ld hl,9
  add hl,de
  ex de,hl
 pop hl
 dec a
 jr nz,sidebar_loop
 ret

disp8bits:
 ld b,0
HUNDplaceDISP8:
 cp 100
 jr c,TENSplaceDISP8

 sub 100
 inc b
 jr HUNDplaceDISP8

TENSplaceDISP8:
 push af
 ld a,b
 or a
 jr z,NOhundDISP8

 ld a,30h		; "0"
 add a,b
 ROM_CALL(M_CHARPUT)

NOhundDISP8:
 pop af
 ld b,0
TENSloopDISP8:
 cp 10
 jr c,ONESplaceDISP8

 sub 10
 inc b
 jr TENSloopDISP8

ONESplaceDISP8:
 push af
 ld a,b
 or a
 jr z,NOtensDISP8
 ld a,30h		; "0"
 add a,b
 ROM_CALL(M_CHARPUT)

NOtensDISP8:
 pop af
 ld b,30h		; "0"
 add a,b
 ROM_CALL(M_CHARPUT)
 ret 

_grbufclr:
 ld hl,GRAPH_MEM
 ld (hl),0
 ld de,GRAPH_MEM+1
 ld bc,767
 ldir
 ret

; SPRITE 
;Ŀ
; Blit or erase SPRITE  a=x, e=y, hl=SPRITE address                         
;
SPRITE:

        push    hl              ; Save SPRITE address
	call findPix

ALIGN:                          ; Blit an aligned SPRITE to graphbuf
        pop     de              ; de->SPRITE
        ld      b,8
ALOP1:  ld      a,(de)
        or      (hl)            ; xor=erase/blit
        ld      (hl),a
        inc     de
        push    bc
        ld      bc,12
        add     hl,bc
        pop     bc
        djnz    ALOP1
	ret

CLRSPR:
        push    hl              ; Save SPRITE address

	call findPix

ALIGN2:                         ; Erase an aligned SPRITE in graphbuf
        pop     de              ; de->SPRITE
        ld      b,8
ALOP2:  ld      a,(de)
        cpl
        and     (hl)
        ld      (hl),a
        inc     de
        push    bc
        ld      bc,12
        add     hl,bc
        pop     bc
        djnz    ALOP2
	ret

findPix:
        ld      hl,0            ; Do y*12
        ld      d,0
        add     hl,de
        add     hl,de
        add     hl,de
        add     hl,hl
        add     hl,hl

        ld      d,0             ; Do x/8
        ld      e,a
        srl     e
        srl     e
        srl     e
        add     hl,de

        ld      de,GRAPH_MEM
        add     hl,de           ; Add address to graphbuf
	ret


; SPRITE 

shot:
 .db 00000000b
 .db 00000000b
 .db 00000000b
 .db 00011000b
 .db 00011000b
 .db 00000000b
 .db 00000000b
 .db 00000000b

SPRITEs:

;grass
  .db 00101010b
  .db 10100000b
  .db 00010101b
  .db 01001000b
  .db 00100010b
  .db 10001100b
  .db 01010001b
  .db 01000010b

;flower 
 .db 00000000b
 .db 00000100b
 .db 00001010b
 .db 01000100b
 .db 10101000b
 .db 01001010b
 .db 01010101b
 .db 01010010b                         ; the SPRITEs themselves 

;fence
 .db 11111111b
 .db 01100110b
 .db 11111111b
 .db 01100110b
 .db 11111111b
 .db 01100110b
 .db 11111111b
 .db 01100110b

;coop1
 .db 00000000b
 .db 00000011b
 .db 00000111b
 .db 00001110b
 .db 00011010b
 .db 00111010b
 .db 01101010b
 .db 11101010b

coop2:
 .db 00000000b
 .db 11000000b
 .db 11100000b
 .db 01110000b
 .db 01011000b
 .db 01011100b
 .db 01010110b
 .db 01010111b

coop3:
 .db 10101010b
 .db 10101111b
 .db 10101000b
 .db 10110011b
 .db 10100111b
 .db 10100111b
 .db 10100111b
 .db 10100111b

coop4:
 .db 01010101b
 .db 11110101b
 .db 00010101b
 .db 11001101b
 .db 11100101b
 .db 11100101b
 .db 11100101b
 .db 11100101b

coop5:
 .db 10100000b
 .db 11111111b
 .db 11001000b
 .db 00001011b
 .db 00001000b
 .db 10101011b
 .db 01001000b
 .db 00011111b

coop6:
 .db 00000101b
 .db 11111111b
 .db 00010011b
 .db 11010000b
 .db 00010000b
 .db 11010101b
 .db 00010010b
 .db 11111000b

chicken:
 .db 00110000b
 .db 01010000b
 .db 11110000b
 .db 00111101b
 .db 01000010b
 .db 00111100b
 .db 00010000b
 .db 00101000b



manl1:
 .db 00011100b
 .db 00111110b
 .db 00010100b
 .db 00001100b
 .db 00010010b
 .db 00010101b
 .db 11111101b
 .db 11111101b

manl2:
 .db 00011111b
 .db 00001110b
 .db 00011011b
 .db 00111011b
 .db 00000000b
 .db 00000000b
 .db 00000000b
 .db 00000000b

manr1:
 .db 00111000b
 .db 01111100b
 .db 00101000b
 .db 00110000b
 .db 01001000b
 .db 10101000b
 .db 10111111b
 .db 10111111b

manr2:
 .db 11111000b
 .db 01110000b
 .db 11011000b
 .db 11011100b
 .db 00000000b
 .db 00000000b
 .db 00000000b
 .db 00000000b

mand1:
 .db 00111000b
 .db 01111100b
 .db 00101000b
 .db 00010000b
 .db 01101100b
 .db 10111010b
 .db 11110110b
 .db 11101100b

mand2:
 .db 01111000b
 .db 01111000b
 .db 01101100b
 .db 01101100b
 .db 00000000b
 .db 00000000b
 .db 00000000b
 .db 00000000b

manu1:
 .db 00111000b
 .db 01111100b
 .db 00111000b
 .db 00010000b
 .db 11101100b
 .db 11111010b
 .db 10111010b
 .db 11111100b

manu2:
 .db 01111000b
 .db 00101000b
 .db 01101100b
 .db 01101100b
 .db 00000000b
 .db 00000000b
 .db 00000000b
 .db 00000000b


; 0 = empty
; 1 = grass
; 2 = flowers
; 4 = wall
; (5-9) = coop(1-6)

map:
 .db 3,3,3,3,3,3,3,3,3,3,3,3,3,3,3
 .db 3,3,3,3,3,3,3,3,3,3,3,3,3,3,3
 .db 3,3,3,3,3,3,3,3,3,3,3,3,3,3,3
 .db 3,3,3,3,3,3,1,1,1,1,1,1,1,1,1
 .db 1,1,1,1,1,3,1,1,1,1,1,1,1,1,1
 .db 1,1,1,1,1,1,1,1,1,3,1,1,1,1,1
 .db 1,1,1,1,1,1,1,1,1,3,3,1,1,0,0
 .db 0,0,0,0,0,0,0,1,1,1,3,1,1,1,0
 .db 0,0,0,2,0,0,0,0,2,0,0,1,1,1,3
 .db 1,1,0,0,0,0,0,0,0,0,0,0,0,1,3
 .db 3,1,0,0,0,0,0,0,0,0,2,0,0,1,1
 .db 3,1,1,0,0,2,0,0,0,0,0,0,0,0,0
 .db 0,0,0,1,3,1,0,0,2,0,0,0,0,0,0
 .db 0,0,0,1,3,3,1,0,4,5,0,0,0,0,0
 .db 0,0,0,0,0,3,3,1,0,0,0,0,0,0,0
 .db 3,2,0,0,0,0,0,0,1,3,1,0,0,0,0
 .db 0,0,0,0,0,4,5,0,1,3,3,1,0,6,7
 .db 0,0,0,2,0,0,0,0,0,0,0,0,0,0,0
 .db 0,2,0,0,1,3,1,0,0,2,0,0,0,1,3
 .db 1,2,0,0,0,0,2,0,0,0,6,7,0,1,3
 .db 3,1,0,8,9,0,0,0,0,0,0,2,0,0,0
 .db 0,0,0,0,0,0,0,0,0,2,3,1,2,0,0
 .db 0,0,0,1,3,1,1,1,1,1,0,0,0,2,0
 .db 8,9,0,1,3,3,1,0,0,0,0,0,2,0,0
 .db 0,0,0,0,1,3,3,1,0,0,2,0,0,0,1
 .db 3,1,0,0,0,2,0,0,1,3,3,3,3,3,3
 .db 3,0,0,0,0,0,0,0,1,3,3,1,0,0,0
 .db 2,0,0,0,0,0,0,0,0,1,3,1,0,0,0
 .db 0,0,0,0,1,3,1,1,1,1,0,0,0,0,0
 .db 0,1,1,1,1,3,0,0,0,0,2,0,0,1,3
 .db 3,1,1,1,0,0,0,0,0,2,0,0,1,1,1
 .db 3,1,0,2,0,0,0,0,0,1,3,3,3,3,3
 .db 3,3,3,3,3,0,0,0,0,1,3,0,0,2,0
 .db 0,0,0,1,3,3,1,1,1,1,1,1,1,1,1
 .db 1,1,1,1,1,3,1,0,0,0,0,0,0,0,1
 .db 3,1,1,1,1,0,0,0,0,0,0,0,1,1,1
 .db 3,0,0,0,0,0,0,0,1,3,3,3,3,3,3
 .db 3,3,3,3,3,3,3,3,3,3,3,1,0,0,0
 .db 0,2,0,0,1,3,1,1,0,0,0,2,0,0,1
 .db 1,1,3,3,3,3,0,0,0,0,2,0,0,1,3
 .db 3,1,1,1,1,1,1,1,1,1,1,1,1,1,1
 .db 1,0,0,0,0,0,0,0,0,1,3,1,0,0,0
 .db 0,0,0,0,1,3,3,3,1,1,0,0,0,0,0
 .db 0,0,0,1,3,3,1,1,0,0,0,0,0,0,0
 .db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,1
 .db 3,1,0,0,0,0,0,0,0,0,0,0,0,0,0
 .db 0,0,0,2,0,0,0,0,1,3,3,1,1,0,0
 .db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
 .db 0,0,1,1,1,3,1,1,1,0,0,0,0,0,0
 .db 0,0,0,0,0,0,0,0,0,0,0,0,1,1,3    ; to 15
 .db 3,1,0,0,0,0,0,0,2,0,0,3,3,3,3,3
 .db 3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3
 .db 3,3,3,3,3,0,0,0,0,0,0,0,3,3,3,3
 .db 3,3,3,1,0,0,2,0,0,0,0,0,0,3,1,1
 .db 1,1,1,1,1,1,1,1,1,1,1,3,1,1,1,1
 .db 1,0,0,0,2,0,0,0,0,0,0,0,0,2,0,1
 .db 1,1,1,3,3,1,0,0,0,0,0,0,0,0,0,3
 .db 1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
 .db 0,2,0,0,2,0,0,0,0,2,0,0,0,0,0,0
 .db 0,0,0,0,1,3,3,1,0,0,0,0,0,2,0,0
 .db 0,3,1,0,0,0,3,3,3,3,3,3,0,0,0,0
 .db 0,0,0,0,0,0,0,3,3,3,3,3,3,0,0,0
 .db 3,3,3,3,3,0,1,3,3,1,0,0,2,0,0,0
 .db 0,0,0,3,1,0,0,1,3,1,0,0,1,3,0,0
 .db 1,3,0,0,0,3,1,0,0,3,0,0,0,0,0,0
 .db 0,0,0,0,0,0,3,0,1,3,3,1,0,0,0,0
 .db 0,0,2,0,0,3,1,0,0,1,3,0,0,0,0,3
 .db 2,0,1,3,0,0,0,3,1,0,0,3,0,0,0,3
 .db 3,3,3,3,3,0,0,0,3,0,1,3,3,1,0,2
 .db 0,0,0,0,0,0,0,3,3,0,0,3,3,0,2,0
 .db 0,3,0,0,1,3,0,0,0,3,1,0,0,3,0,0
 .db 0,0,0,0,0,0,0,0,0,0,3,0,1,3,3,1
 .db 0,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0
 .db 0,0,1,3,0,0,1,3,0,0,0,3,1,0,0,3
 .db 0,3,0,3,3,0,0,3,3,0,3,0,3,0,1,3
 .db 3,1,1,1,1,0,0,0,0,2,0,0,0,0,0,0
 .db 0,0,0,1,1,3,0,0,1,3,0,0,0,3,1,0
 .db 0,3,0,3,0,3,0,0,0,0,3,0,3,0,3,0
 .db 1,3,3,3,3,3,3,3,3,3,3,0,0,0,0,0
 .db 0,3,3,3,3,3,3,3,0,0,1,3,0,0,0,3
 .db 1,0,2,0,0,3,0,3,0,4,5,0,3,0,3,0
 .db 0,0,1,3,3,1,1,1,1,0,0,0,0,0,2,0
 .db 0,0,0,0,0,0,0,1,1,3,0,0,1,3,0,0
 .db 0,3,1,0,0,0,0,3,0,3,0,6,7,0,3,0
 .db 3,0,0,0,1,3,3,1,0,0,0,0,2,0,0,0
 .db 0,0,0,0,0,0,0,2,0,0,1,3,0,0,1,3
 .db 0,0,0,3,1,0,0,0,0,3,0,3,0,8,9,0
 .db 3,0,3,0,0,0,1,3,3,1,0,0,0,0,0,0
 .db 0,0,0,0,0,2,0,0,0,0,0,0,1,3,0,0
 .db 1,3,0,0,0,3,1,0,0,3,0,3,0,3,0,0
 .db 0,0,3,0,3,0,3,0,1,3,3,1,0,0,0,0
 .db 0,2,0,0,0,0,0,0,0,0,0,2,0,0,1,3
 .db 0,0,1,3,0,0,0,3,1,0,0,3,0,3,0,3
 .db 3,0,0,3,3,0,3,0,3,0,1,3,3,1,0,0
 .db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
 .db 0,3,0,0,1,3,0,0,0,3,1,0,0,3,0,3
 .db 0,0,0,0,0,0,0,0,0,0,3,0,1,3,3,1
 .db 0,2,0,0,0,0,3,3,3,3,3,3,3,3,3,3
 .db 0,0,0,3,0,0,1,3,0,0,0,3,1,0,0,3
 .db 0,0,0,3,3,3,3,3,3,0,0,0,3,0,1,3
 .db 3,1,0,0,0,0,0,0,3,1,1,0,0,0,1,1
 .db 1,3,0,2,0,3,0,0,1,3,0,0,0,3,1,0
 .db 0,3,0,0,0,0,0,0,0,0,0,0,0,0,3,0
 .db 1,3,3,1,0,0,0,2,0,0,3,1,0,0,0,0
 .db 0,0,1,3,1,0,0,0,0,0,1,3,0,0,0,3
 .db 1,0,0,3,3,3,3,3,3,0,0,0,3,3,3,3
 .db 3,0,1,3,3,1,0,0,0,0,0,0,3,0,0,0
 .db 4,5,0,0,0,3,3,3,0,0,0,0,1,3,0,0
 .db 0,3,1,0,0,0,0,0,2,0,0,0,0,0,0,0
 .db 0,0,0,0,1,3,3,1,0,2,0,0,0,0,3,0
 .db 0,0,6,7,0,0,0,3,1,0,0,0,2,0,1,3
 .db 0,0,0,3,1,0,0,0,0,0,0,0,0,0,0,0
 .db 0,0,0,0,2,0,1,3,3,1,0,0,0,0,0,0
 .db 0,2,0,0,8,9,0,0,1,3,0,0,0,3,3,3
 .db 3,3,0,0,0,3,3,3,3,3,3,3,3,0,0,0
 .db 3,3,3,3,0,0,0,0,1,3,3,1,0,0,0,0
 .db 2,0,0,0,0,0,0,0,0,0,1,3,0,0,0,1
 .db 3,1,0,0,0,0,0,0,0,1,1,3,1,0,0,0
 .db 0,0,0,0,1,3,0,0,0,0,1,3,3,1,0,0
 .db 0,0,0,0,0,0,0,0,0,0,2,0,1,3,0,2
 .db 0,0,0,0,0,2,0,0,0,2,0,0,0,0,0,0
 .db 0,0,0,2,0,0,0,0,0,2,0,0,1,3,3,1
 .db 1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,3
 .db 1,1,1,1,3,1,0,0,0,0,0,0,0,0,1,3
 .db 1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,3
 .db 3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3
 .db 3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3
 .db 3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3   ; big... eh?

sidebar:
    .db     127,255,255,96,0,3,76,32,33,84,34,73,124,37,109,79,102,73,80,187,69,79,0,1,68,0,1,74,0,1,64
    .db     0,1,64,0,1,64,0,1,64,0,1,96,0,3,127,255,255,64,0,1,127,255,255,127,255,255,127,193,255,126,0
    .db     63,120,8,15,112,8,7,96,0,3,96,0,3,64,8,1,64,8,1,64,0,1,64,0,1,64,8,1,64,8,1
    .db     115,54,103,64,8,1,64,8,1,64,0,1,64,0,1,64,8,1,64,8,1,96,0,3,96,0,3,112,8,7,120
    .db     8,15,126,0,63,127,193,255,127,255,255,127,255,255,64,0,1,127,255,255,96,0,3,78,128,1,68,52,73,68,170
    .db     161,68,170,201,68,162,97,64,0,1,64,0,1,64,0,1,64,0,1,64,0,1,64,0,1,64,0,1,64,0,1
    .db     96,0,3,127,255,255,112

cstitl:
    .db     1,192,0,224,0,0,0,0,224,0,56,7,249,192,0,224,0,0
    .db     3,248,224,0,56,31,252,194,0,192,0,0,15,254,192,0,16,60,30,199,0,192,0,0,28,6,192,0,16,56,6
    .db     198,0,192,0,0,28,0,192,0,146,112,2,194,0,192,1,128,28,0,192,0,254,112,0,192,0,206,3,128,15,0
    .db     64,0,254,96,0,247,0,78,1,224,7,248,115,207,90,112,1,250,126,88,123,240,1,252,251,109,152,112,3,202,239
    .db     113,253,16,0,14,206,56,152,48,5,203,131,99,133,16,0,7,68,48,144,56,13,139,128,115,253,16,0,3,68,48
    .db     144,30,61,139,128,123,225,144,0,6,196,48,144,15,249,139,129,121,135,16,3,254,206,121,144,3,192,138,255,110,253
    .db     48,15,252,203,239,144,0,0,146,124,78,1,32,14,0,73,199,16,0,0,130,0,64,1,0,8,0,64,0,16,0
    .db     0,130,0,64,1,0,0,0,64,0,16,0,0,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0


hiscs: .db 255,255,255,255,255,255,255,255

win1: .db "Yew Plum Kilt Them Chikins",0
tstr: .db "Time: ",0

intro_text1: .db "Level",0
intro_text2: .db "Tyme Left: ",0
intro_text3: .db "Rekerd: ",0

aNewHighScore_String: .db "New High Score",0
paused: .db "*Paused*",0
gmover: .db "Out Of Time",0

.end
.END